function render(vNode) {
  var element = document.createElement(vNode.tagName);
  var props = vNode.props;

  for (var key in props) {
    var value = props[key];
    element.setAttribute(key, value);
  }

  vNode.children && vNode.children(function (child) {
    var childElement = typeof child === 'string' ? document.createTextNode(child) : render(child);
    element.appendChild(childElement);
  });
  return element;
}

export default render;