// @ts-ignore
import * as R from 'ramda';
import * as ELE from '../../elements';
import transform from '../operations/transform';
import renderText from '../elements/renderText';
import renderRect from '../elements/renderRect';
import renderImage from '../elements/renderImage';
var isText = R.propEq('type', ELE.Text);
var isRect = R.propEq('type', ELE.Rect);
var isImage = R.propEq('type', ELE.Image);

var shouldRenderChildren = function shouldRenderChildren(v) {
  return !isText(v);
};

var renderChildren = function renderChildren(nodeGroup) {
  return function (node) {
    var subGroup = nodeGroup.addGroup();

    if (node.box) {
      // 偏移子元素
      subGroup.translate(node.box.left, node.box.top);
    }

    R.compose(R.forEach(renderNode(subGroup)), R.pathOr([], ['children']))(node);
    return node;
  };
};

var renderNode = function renderNode(nodeGroup) {
  return function (node) {
    return R.compose(R.when(shouldRenderChildren, renderChildren(nodeGroup)), R.cond([[isText, renderText(nodeGroup)], [isRect, renderRect(nodeGroup)], [isImage, renderImage(nodeGroup)], [R.T, R.identity]]), transform(nodeGroup) // @ts-ignore
    )(node);
  };
};

export default renderNode;