import * as R from 'ramda';

var applySingleTransformation = function applySingleTransformation(ctx, transform) {
  var operation = transform.operation,
      value = transform.value;

  switch (operation) {
    case 'scale':
      {
        var scaleX = value[0],
            scaleY = value[1]; // ctx.scale(scaleX, scaleY, { origin });

        break;
      }

    case 'rotate':
      {
        var angle = value[0]; // ctx.rotate(angle, { origin });

        break;
      }

    case 'translate':
      {
        var x = value[0],
            y = value[1]; // ctx.translate(x, y, { origin });

        break;
      }

    case 'matrix':
      {
        // ctx.transform(...value);
        break;
      }

    default:
      {
        console.error("Transform operation: '" + operation + "' doesn't supported");
      }
  }
};

var applyTransformations = function applyTransformations(ctx, node) {
  if (!node.origin) return node;
  var origin = [node.origin.left, node.origin.top];
  var operations = node.style && node.style.transform || [];
  operations.forEach(function (operation) {
    applySingleTransformation(ctx, operation);
  });
  return node;
};

export default R.curryN(2, applyTransformations);