// render to g6 node
import layoutShape from '../layout';
import renderShape from '../render';
import { createRenderer } from './renderer';
import diff from '../diff';
import patch from '../diff/patches';
export var GRenderer = /*#__PURE__*/function () {
  function GRenderer(element, renderer, callback) {
    this.element = null;
    this.renderer = null;
    this.callback = null;
    this.layout = null;
    this.newLayout = null;
    this.element = element;
    this.renderer = renderer;
    this.callback = callback;
  }

  var _proto = GRenderer.prototype;

  _proto.calculateLayout = function calculateLayout() {
    var container = {
      type: 'ROOT',
      shape: null
    };
    var renderer = this.renderer || createRenderer({
      onChange: this.callback ? this.callback : function () {}
    });
    var newRoot = renderer.createContainer(container);

    var updateContainer = function updateContainer(element) {
      renderer.updateContainer(element, newRoot, null);
    };

    if (this.element) updateContainer(this.element); // cache layout

    this.layout = layoutShape(container.shape);
    return this.layout;
  };

  _proto.reCalculateLayout = function reCalculateLayout(element) {
    this.element = element;
    var container = {
      type: 'ROOT',
      shape: null
    };
    var renderer = this.renderer || createRenderer({
      onChange: this.callback ? this.callback : function () {}
    });
    var newRoot = renderer.createContainer(container);

    var updateContainer = function updateContainer(element) {
      renderer.updateContainer(element, newRoot, null);
    };

    if (this.element) updateContainer(this.element); // cache layout

    this.newLayout = layoutShape(container.shape);
    return this.newLayout;
  };

  _proto.render = function render(gGroupContainer, layoutInfo) {
    var layout = layoutInfo || this.layout || this.calculateLayout();
    return renderShape(gGroupContainer, layout);
  };

  _proto.update = function update(gGroupContainer, layoutInfo, element) {
    // 更新节点  兜底第一次渲染
    var layout = layoutInfo || this.newLayout || this.reCalculateLayout(element) || this.layout || this.calculateLayout();
    var patches = diff(this.layout, this.newLayout);
    patch(this.layout, patches, gGroupContainer); // 更新完节点把最新layout覆盖老layout

    this.layout = this.newLayout; // const shape = gGroupContainer.findAll(
    //   (allItem: any) => allItem.attr('name') && allItem.attr('name').indexOf('g-react') > -1,
    // );
    // shape.forEach((shapeItem: any) => {
    //   shapeItem.remove();
    // });
    // return renderShape(gGroupContainer, layout);
  };

  return GRenderer;
}();