interface IShadowStyle {
    shadowOffsetX?: string | number;
    shadowOffsetY?: string | number;
    shadowBlur?: string | number;
    shadowColor?: string;
}
interface IOpacityStyle {
    opacity?: number;
    fillOpacity?: number;
    strokeOpacity?: number;
}
export declare const i18n: (key: string) => any;
export declare const formatCssNumber: (value: number | string) => number;
/**
 * 判断是否合法的透明度值，范围是 [0, 1]
 * @param value Number 透明度值
 * @returns Boolean
 */
export declare const isAlphaNumber: (value: any) => boolean;
/**
 * 获取元素的阴影样式
 * @param style IShadowStyle 阴影样式
 * @returns IShadowStyle
 */
export declare const getShadowStyle: (style: IShadowStyle) => IShadowStyle;
/**
 * 获取元素的透明度样式
 * @param style IOpacityStyle 透明度样式
 * @returns IOpacityStyle
 */
export declare const getOpacityStyle: (style: IOpacityStyle) => IOpacityStyle;
export {};
