"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.resolveShapeDimensions = exports["default"] = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _yoga = _interopRequireDefault(require("@react-pdf/yoga"));

var ELE = _interopRequireWildcard(require("../elements"));

var _getMargin = _interopRequireDefault(require("@react-pdf/layout/lib/node/getMargin"));

var _getPadding = _interopRequireDefault(require("@react-pdf/layout/lib/node/getPadding"));

var _getPosition = _interopRequireDefault(require("@react-pdf/layout/lib/node/getPosition"));

var _getDimension = _interopRequireDefault(require("@react-pdf/layout/lib/node/getDimension"));

var _getBorderWidth = _interopRequireDefault(require("@react-pdf/layout/lib/node/getBorderWidth"));

var _setDisplay = _interopRequireDefault(require("@react-pdf/layout/lib/node/setDisplay"));

var _setOverflow = _interopRequireDefault(require("@react-pdf/layout/lib/node/setOverflow"));

var _setFlexWrap = _interopRequireDefault(require("@react-pdf/layout/lib/node/setFlexWrap"));

var _setFlexGrow = _interopRequireDefault(require("@react-pdf/layout/lib/node/setFlexGrow"));

var _setFlexBasis = _interopRequireDefault(require("@react-pdf/layout/lib/node/setFlexBasis"));

var _setAlignSelf = _interopRequireDefault(require("@react-pdf/layout/lib/node/setAlignSelf"));

var _setAlignItems = _interopRequireDefault(require("@react-pdf/layout/lib/node/setAlignItems"));

var _setFlexShrink = _interopRequireDefault(require("@react-pdf/layout/lib/node/setFlexShrink"));

var _setAspectRatio = _interopRequireDefault(require("@react-pdf/layout/lib/node/setAspectRatio"));

var _setAlignContent = _interopRequireDefault(require("@react-pdf/layout/lib/node/setAlignContent"));

var _setPositionType = _interopRequireDefault(require("@react-pdf/layout/lib/node/setPositionType"));

var _setFlexDirection = _interopRequireDefault(require("@react-pdf/layout/lib/node/setFlexDirection"));

var _setJustifyContent = _interopRequireDefault(require("@react-pdf/layout/lib/node/setJustifyContent"));

var _setMargin = require("@react-pdf/layout/lib/node/setMargin");

var _setPadding = require("@react-pdf/layout/lib/node/setPadding");

var _setBorderWidth = require("@react-pdf/layout/lib/node/setBorderWidth");

var _setPosition = require("@react-pdf/layout/lib/node/setPosition");

var _setDimension = require("@react-pdf/layout/lib/node/setDimension");

var _measureText = require("../util/measureText");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// import measureText from '@react-pdf/layout/lib/text/measureText';
var YOGA_NODE = '_yogaNode';

var YOGA_CONFIG = _yoga["default"].Config.create();

YOGA_CONFIG.setPointScaleFactor(0);
var isType = R.propEq('type');
var isText = isType(ELE.Text); // const isImage = isType(P.Image);

var isTextInstance = isType(ELE.TextInstance);

var setNodeHeight = function setNodeHeight(node) {
  var box = node.box || {};
  var style = node.style || {};
  return (0, _setDimension.setHeight)(box.height || style.height);
};
/**
 * Set styles valeus into yoga node before layout calculation
 *
 * @param {Object} node
 * @returns {Object} node
 */


var setYogaValues = R.tap(function (node) {
  if (!node || !node.style) return;
  R.compose(setNodeHeight(node), (0, _setDimension.setWidth)(node.style.width), (0, _setDimension.setMinWidth)(node.style.minWidth), (0, _setDimension.setMaxWidth)(node.style.maxWidth), (0, _setDimension.setMinHeight)(node.style.minHeight), (0, _setDimension.setMaxHeight)(node.style.maxHeight), (0, _setMargin.setMarginTop)(node.style.marginTop), (0, _setMargin.setMarginRight)(node.style.marginRight), (0, _setMargin.setMarginBottom)(node.style.marginBottom), (0, _setMargin.setMarginLeft)(node.style.marginLeft), (0, _setPadding.setPaddingTop)(node.style.paddingTop), (0, _setPadding.setPaddingRight)(node.style.paddingRight), (0, _setPadding.setPaddingBottom)(node.style.paddingBottom), (0, _setPadding.setPaddingLeft)(node.style.paddingLeft), (0, _setPositionType["default"])(node.style.position), (0, _setPosition.setPositionTop)(node.style.top), (0, _setPosition.setPositionRight)(node.style.right), (0, _setPosition.setPositionBottom)(node.style.bottom), (0, _setPosition.setPositionLeft)(node.style.left), (0, _setBorderWidth.setBorderTop)(node.style.borderTopWidth), (0, _setBorderWidth.setBorderRight)(node.style.borderRightWidth), (0, _setBorderWidth.setBorderBottom)(node.style.borderBottomWidth), (0, _setBorderWidth.setBorderLeft)(node.style.borderLeftWidth), (0, _setDisplay["default"])(node.style.display), (0, _setFlexDirection["default"])(node.style.flexDirection), (0, _setAlignSelf["default"])(node.style.alignSelf), (0, _setAlignContent["default"])(node.style.alignContent), (0, _setAlignItems["default"])(node.style.alignItems), (0, _setJustifyContent["default"])(node.style.justifyContent), (0, _setFlexWrap["default"])(node.style.flexWrap), (0, _setOverflow["default"])(node.style.overflow), (0, _setAspectRatio["default"])(node.style.aspectRatio), (0, _setFlexBasis["default"])(node.style.flexBasis), (0, _setFlexGrow["default"])(node.style.flexGrow), (0, _setFlexShrink["default"])(node.style.flexShrink))(node);
});
/**
 * Inserts child into parent' yoga node
 *
 * @param {Object} parent
 * @param {Object} node
 * @param {Object} node
 */

var insertYogaNodes = function insertYogaNodes(parent) {
  return R.tap(function (child) {
    return parent.insertChild(child[YOGA_NODE], parent.getChildCount());
  });
};

var setMeasureFunc = function setMeasureFunc(shape) {
  return function (node) {
    var yogaNode = node[YOGA_NODE]; // TODO: 改进性能

    if (isText(node)) {
      yogaNode.setMeasureFunc(function (width, widthMode, height, heightMode) {
        var textIns = node.children[0];

        if (textIns && textIns.type === 'TEXT_INSTANCE') {
          // console.log('measure text', textIns.value);
          // console.log('measure node', node, width, widthMode, height, heightMode);
          var textInfo = (0, _measureText.measureText)(textIns.value, node.style); // console.log('measured text info', textInfo);

          return {
            width: textInfo.width > node.style.maxWidth ? node.style.maxWidth : textInfo.width,
            height: textInfo.height
          };
        }

        return {
          height: height,
          width: width
        };
      });
    } //
    // if (isImage(node)) {
    //     yogaNode.setMeasureFunc(measureImage(page, node));
    // }
    //
    // if (isCanvas(node)) {
    //     yogaNode.setMeasureFunc(measureCanvas(page, node));
    // }
    //
    // if (isSvg(node)) {
    //     yogaNode.setMeasureFunc(measureSvg(page, node));
    // }


    return node;
  };
};

var isNotText = R.complement(isText); // const isNotNote = R.complement(isNote);
// const isNotSvg = R.complement(isSvg);

var isNotTextInstance = R.complement(isTextInstance); // const isLayoutElement = R.allPass([isNotText, isNotNote, isNotSvg]);

var isLayoutElement = R.allPass([isNotText]);
/**
 * Creates and add yoga node to document tree
 * Handles measure function for text and image nodes
 *
 * @param {Object} node
 * @returns {Object} node with appended yoga node
 */

var createYogaNodes = function createYogaNodes(shape, config) {
  if (config === void 0) {
    config = {};
  }

  return function (node) {
    var yogaNode = _yoga["default"].Node.createWithConfig(YOGA_CONFIG);

    return R.compose(setMeasureFunc(shape, config), R.when(isLayoutElement, R.evolve({
      children: R.map(R.compose(insertYogaNodes(yogaNode), createYogaNodes(shape, config)))
    })), setYogaValues, R.assoc(YOGA_NODE, yogaNode))(node);
  };
};
/**
 * Performs yoga calculation
 *
 * @param {Object} node
 * @returns {Object} node
 */


var calculateLayout = function calculateLayout(shape) {
  shape[YOGA_NODE].calculateLayout();
  return shape;
};
/**
 * Saves Yoga layout result into 'box' attribute of node
 *
 * @param {Object} node
 * @returns {Object} node with box data
 */


var persistDimensions = function persistDimensions(node) {
  return R.evolve({
    children: R.map(R.when(isNotTextInstance, persistDimensions)),
    box: R.always(R.mergeAll([(0, _getPadding["default"])(node), (0, _getMargin["default"])(node), (0, _getBorderWidth["default"])(node), (0, _getPosition["default"])(node), (0, _getDimension["default"])(node)]))
  })(node);
};
/**
 * Removes yoga node from document tree
 *
 * @param {Object} node
 * @returns {Object} node without yoga node
 */


var destroyYogaNodes = function destroyYogaNodes(node) {
  return R.compose(R.dissoc(YOGA_NODE), R.evolve({
    children: R.map(destroyYogaNodes)
  }))(node);
};
/**
 * Free yoga node from document tree
 *
 * @param {Object} node
 * @returns {Object} node without yoga node
 */


var freeYogaNodes = function freeYogaNodes(node) {
  if (node[YOGA_NODE]) node[YOGA_NODE].freeRecursive();
  return node;
};
/**
 * Calculates page object layout using Yoga.
 * Takes node values from 'box' and 'style' attributes, and persist them back into 'box'
 * Destroy yoga values at the end.
 *
 * @param {Object} shape object
 * @returns {Object} shape object with correct 'box' layout attributes
 */


var resolveShapeDimensions = function resolveShapeDimensions(shape) {
  return R.ifElse(R.isNil, R.always(null), R.compose(destroyYogaNodes, freeYogaNodes, persistDimensions, calculateLayout, createYogaNodes(shape)))(shape);
};

exports.resolveShapeDimensions = resolveShapeDimensions;
var _default = resolveShapeDimensions;
exports["default"] = _default;