"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var R = _interopRequireWildcard(require("ramda"));

var ELE = _interopRequireWildcard(require("../../elements"));

var _transform = _interopRequireDefault(require("../operations/transform"));

var _renderText = _interopRequireDefault(require("../elements/renderText"));

var _renderRect = _interopRequireDefault(require("../elements/renderRect"));

var _renderImage = _interopRequireDefault(require("../elements/renderImage"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// @ts-ignore
var isText = R.propEq('type', ELE.Text);
var isRect = R.propEq('type', ELE.Rect);
var isImage = R.propEq('type', ELE.Image);

var shouldRenderChildren = function shouldRenderChildren(v) {
  return !isText(v);
};

var renderChildren = function renderChildren(nodeGroup) {
  return function (node) {
    var subGroup = nodeGroup.addGroup();

    if (node.box) {
      // 偏移子元素
      subGroup.translate(node.box.left, node.box.top);
    }

    R.compose(R.forEach(renderNode(subGroup)), R.pathOr([], ['children']))(node);
    return node;
  };
};

var renderNode = function renderNode(nodeGroup) {
  return function (node) {
    return R.compose(R.when(shouldRenderChildren, renderChildren(nodeGroup)), R.cond([[isText, (0, _renderText["default"])(nodeGroup)], [isRect, (0, _renderRect["default"])(nodeGroup)], [isImage, (0, _renderImage["default"])(nodeGroup)], [R.T, R.identity]]), (0, _transform["default"])(nodeGroup) // @ts-ignore
    )(node);
  };
};

var _default = renderNode;
exports["default"] = _default;