"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.GRenderer = void 0;

var _layout = _interopRequireDefault(require("../layout"));

var _render = _interopRequireDefault(require("../render"));

var _renderer = require("./renderer");

var _diff = _interopRequireDefault(require("../diff"));

var _patches = _interopRequireDefault(require("../diff/patches"));

// render to g6 node
var GRenderer = /*#__PURE__*/function () {
  function GRenderer(element, renderer, callback) {
    this.element = null;
    this.renderer = null;
    this.callback = null;
    this.layout = null;
    this.newLayout = null;
    this.element = element;
    this.renderer = renderer;
    this.callback = callback;
  }

  var _proto = GRenderer.prototype;

  _proto.calculateLayout = function calculateLayout() {
    var container = {
      type: 'ROOT',
      shape: null
    };
    var renderer = this.renderer || (0, _renderer.createRenderer)({
      onChange: this.callback ? this.callback : function () {}
    });
    var newRoot = renderer.createContainer(container);

    var updateContainer = function updateContainer(element) {
      renderer.updateContainer(element, newRoot, null);
    };

    if (this.element) updateContainer(this.element); // cache layout

    this.layout = (0, _layout["default"])(container.shape);
    return this.layout;
  };

  _proto.reCalculateLayout = function reCalculateLayout(element) {
    this.element = element;
    var container = {
      type: 'ROOT',
      shape: null
    };
    var renderer = this.renderer || (0, _renderer.createRenderer)({
      onChange: this.callback ? this.callback : function () {}
    });
    var newRoot = renderer.createContainer(container);

    var updateContainer = function updateContainer(element) {
      renderer.updateContainer(element, newRoot, null);
    };

    if (this.element) updateContainer(this.element); // cache layout

    this.newLayout = (0, _layout["default"])(container.shape);
    return this.newLayout;
  };

  _proto.render = function render(gGroupContainer, layoutInfo) {
    var layout = layoutInfo || this.layout || this.calculateLayout();
    return (0, _render["default"])(gGroupContainer, layout);
  };

  _proto.update = function update(gGroupContainer, layoutInfo, element) {
    // 更新节点  兜底第一次渲染
    var layout = layoutInfo || this.newLayout || this.reCalculateLayout(element) || this.layout || this.calculateLayout();
    var patches = (0, _diff["default"])(this.layout, this.newLayout);
    (0, _patches["default"])(this.layout, patches, gGroupContainer); // 更新完节点把最新layout覆盖老layout

    this.layout = this.newLayout; // const shape = gGroupContainer.findAll(
    //   (allItem: any) => allItem.attr('name') && allItem.attr('name').indexOf('g-react') > -1,
    // );
    // shape.forEach((shapeItem: any) => {
    //   shapeItem.remove();
    // });
    // return renderShape(gGroupContainer, layout);
  };

  return GRenderer;
}();

exports.GRenderer = GRenderer;